=== debian/changelog ===
xen (4.0.1-5.11) squeeze-security; urgency=low

  * Apply fix for Xen Security Advisory 45 (CVE-2013-1918)
  * Apply fix for Xen Security Advisory 49 (CVE-2013-1952)
  * Apply fix for Xen Security Advisory 50 (CVE-2013-1964)

 -- Guido Trotter <ultrotter@debian.org>  Thu, 02 May 2013 14:19:40 +0000

xen (4.0.1-5.10) squeeze-security; urgency=low

  * Apply fix for Xen Security Advisory 44 (CVE-2013-1917)
    - x86: clear EFLAGS.NT in SYSENTER entry path
  * Apply fix for Xen Security Advisory 46 (CVE_2013-1919)
    - x86: fix various issues with handling guest IRQs

 -- Ian Campbell <ijc@hellion.org.uk>  Wed, 17 Apr 2013 11:39:33 +0100

xen (4.0.1-5.8) stable-security; urgency=low

  * Correct fix for CVE-2012-4544 (Closes: #702046)

 -- Ian Campbell <ijc@hellion.org.uk>  Sat, 02 Mar 2013 09:23:14 +0000

xen (4.0.1-5.7) stable-security; urgency=low

  * Non-maintainer upload, previously discussed with Guido.
  * Apply fix for Xen Security Advisory 25 (CVE-2012-4544)
    - libxc: Do not use dom0 physmem as parameter to lzma decoder
    - libxc: builder: limit maximum size of kernel/ramdisk
  * Apply fix for Xen Security Advisory 27 (CVE-2012-5511)
    - hvm: Limit the size of large HVM op batches
    - x86/mm: Fix loop increment in paging_log_dirty_range()
  * Apply fix for Xen Security Advisory 33 (CVE-2012-5634)
    - VT-d: fix interrupt remapping source validation for devices behind legacy
      bridges
  * Apply fix for Xen Security Advisory 36 (CVE-2013-0153)
    - AMD IOMMU: Fix an interrupt remapping issue
    - Backport per-device vector map patches to xen 4.1.3
    - x86: IRQ fix incorrect logic in __clear_irq_vector
    - x86/IRQ: prevent vector sharing within IO-APICs
    - ACPI: acpi_table_parse() should return handler's error code
    - AMD,IOMMU: Clean up old entries in remapping tables when creating new one
    - AMD,IOMMU: Disable IOMMU if SATA Combined mode is on
    - AMD,IOMMU: Make per-device interrupt remapping table default
    - AMD IOMMU: also spot missing IO-APIC entries in IVRS table

 -- Ian Campbell <ijc@hellion.org.uk>  Thu, 07 Feb 2013 12:56:18 +0000

xen (4.0.1-5.6) stable-proposed-updates; urgency=low

  * Non-maintainer upload, previously discussed with Guido.
  * Fixes Xen clock long standing issue, eg: fix scale_delta() inline assembly,
  causing domU offset and possibly leading to crashes (Closes: #599161). Thanks
  to Ian Campbell <ijc@hellion.org.uk> for forwarding the patch to the Debian
  BTS, and Jan Beulich <jbeulich@suse.com> for working on an upstream patch.

 -- Thomas Goirand <zigo@debian.org>  Wed, 26 Dec 2012 13:18:34 +0000

xen (4.0.1-5.5) stable-security; urgency=high

  * Apply fix for Xen Security Advisory 5 (CVE-2011-3131)
  * Apply fix for Xen Security Advisory 20 (CVE-2012-4535)
  * Apply fix for Xen Security Advisory 22 (CVE-2012-4537)
  * Apply fix for Xen Security Advisory 23 (CVE-2012-4538)
  * Apply fix for Xen Security Advisory 24 (CVE-2012-4539)
  * Apply fix for Xen Security Advisory 26 (CVE-2012-5510)
  * Apply fix for Xen Security Advisory 29 (CVE-2012-5513)
  * Apply fix for Xen Security Advisory 30 (CVE-2012-5514)
  * Apply fix for Xen Security Advisory 31 (CVE-2012-5515)

 -- Guido Trotter <ultrotter@debian.org>  Thu, 06 Dec 2012 16:47:23 +0100

xen (4.0.1-5.4) stable-security; urgency=high

  * Apply fix for Xen Security Advisory 12 (CVE-2012-3494)
  * Apply fix for Xen Security Advisory 14 (CVE-2012-3496) 

 -- Guido Trotter <ultrotter@debian.org>  Sat, 08 Sep 2012 11:32:09 +0000

xen (4.0.1-5.3) stable-security; urgency=high

  * Apply patch for CVE-2012-3432 (closes: #683279)
  * Apply patch for CVE-2012-3433

 -- Guido Trotter <ultrotter@debian.org>  Tue, 14 Aug 2012 14:47:43 +0000

xen (4.0.1-5.2) stable-security; urgency=high

  * Apply patch from SuSE to boot even if the hardware is affected by
    CVE-2012-2934.

 -- Florian Weimer <fw@deneb.enyo.de>  Thu, 21 Jun 2012 08:26:24 +0200

xen (4.0.1-5) stable-security; urgency=low

  * Fix privilege escalation and syscall/sysenter DoS while using
    non-canonical addresses by untrusted PV guests.
    CVE-2012-0217
    CVE-2012-0218
  * Disable Xen on CPUs affected by AMD Erratum #121. PV guests can
    cause a DoS of the host.
    CVE-2012-2934

 -- Bastian Blank <waldi@debian.org>  Mon, 11 Jun 2012 18:12:37 +0000

xen (4.0.1-4) stable-security; urgency=low

  * Fix overflows and missing error checks in PV kernel loader.
    CVE-2011-1583
  * Protect against malicious MSIs from untrusted devices.
    CVE-2011-1898

 -- Bastian Blank <waldi@debian.org>  Thu, 09 Jun 2011 20:33:46 +0200

xen (4.0.1-3) stable-security; urgency=low

  * Fix check for existance of user-mode page tables.
    CVE-2011-1166

 -- Bastian Blank <waldi@debian.org>  Sat, 16 Apr 2011 12:15:01 +0000

xen (4.0.1-2) unstable; urgency=low

  * Fix races in memory management.
  * Make sure that frame-table compression leaves enough alligned.
  * Disable XSAVE support. (closes: #595490)
  * Check for dying domain instead of raising an assertion.
  * Add C6 state with EOI errata for Intel.
  * Make some memory management interrupt safe. Unsure if really needed.
  * Raise bar for inter-socket migrations on mostly-idle systems.
  * Fix interrupt handling for legacy routed interrupts.
  * Allow to set maximal domain memory even during a running change.
  * Support new partition name in pygrub. (closes: #599243)
  * Fix some comparisions "< 0" that may be optimized away.
  * Check for MWAIT support before using it.
  * Fix endless loop on interrupts on Nehalem cpus.
  * Don't crash upon direct GDT/LDT access. (closes: #609531)
    CVE-2010-4255  
  * Don't loose timer ticks after domain restore.
  * Reserve some space for IOMMU area in dom0. (closes: #608715)
  * Fix hypercall arguments after trace callout.
  * Fix some error paths in vtd support. Memory leak.
  * Reinstate ACPI DMAR table.

 -- Bastian Blank <waldi@debian.org>  Wed, 12 Jan 2011 15:01:40 +0100

xen (4.0.1-1) unstable; urgency=low


